--- emacs24-24.3+1.orig/lisp/progmodes/cc-engine.el
+++ emacs24-24.3+1/lisp/progmodes/cc-engine.el
@@ -10023,7 +10228,7 @@ comment at the start of cc-engine.el for
 			  (setq placeholder (point)))
 			nil)))))
 	  ;; For historic reasons we anchor at bol of the last
-	  ;; line of the previous declaration.  That's clearly
+	  ;; line of the previous declaration.	That's clearly
 	  ;; highly bogus and useless, and it makes our lives hard
 	  ;; to remain compatible.  :P
 	  (goto-char placeholder)
@@ -10079,19 +10284,19 @@ comment at the start of cc-engine.el for
 	  (c-beginning-of-statement-1 containing-sexp)
 	  (c-add-stmt-syntax 'statement nil t containing-sexp paren-state))
 
-	 ;;CASE 5N: We are at a topmost continuation line and the only
-	 ;;preceding items are annotations.
+     ;;CASE 5N: We are at a tompmost continuation line and the only
+     ;;preceding items are annotations.
 	 ((and (c-major-mode-is 'java-mode)
 	       (setq placeholder (point))
-	       (c-beginning-of-statement-1)
-	       (progn
+           (c-beginning-of-statement-1)
+           (progn
 		 (while (and (c-forward-annotation))
-		   (c-forward-syntactic-ws))
-		 t)
-	       (prog1
-		   (>= (point) placeholder)
-		 (goto-char placeholder)))
-	  (c-add-syntax 'annotation-top-cont (c-point 'boi)))
+	       (c-forward-syntactic-ws))
+	     t)
+	   (prog1
+             (>= (point) placeholder)
+             (goto-char placeholder)))
+      (c-add-syntax 'annotation-top-cont (c-point 'boi)))
 
 	 ;; CASE 5M: we are at a topmost continuation line
 	 (t
@@ -10106,7 +10311,6 @@ comment at the start of cc-engine.el for
 	  (c-add-syntax 'topmost-intro-cont (c-point 'boi)))
 	 ))
 
-
        ;; (CASE 6 has been removed.)
 
        ;; CASE 7: line is an expression, not a statement.  Most
@@ -10206,14 +10410,14 @@ comment at the start of cc-engine.el for
 	 ;; but the preceding argument is on the same line as the
 	 ;; opening paren.  This case includes multi-line
 	 ;; mathematical paren groupings, but we could be on a
-	 ;; for-list continuation line.  C.f. case 7A.
+	 ;; for-list continuation line.	 C.f. case 7A.
 	 ((progn
 	    (goto-char (1+ containing-sexp))
 	    (< (save-excursion
 		 (c-forward-syntactic-ws)
 		 (point))
 	       (c-point 'bonl)))
-	  (goto-char containing-sexp)	; paren opening the arglist
+	  (goto-char containing-sexp)
 	  (setq placeholder (c-point 'boi))
 	  (if (and (c-safe (backward-up-list 1) t)
 		   (>= (point) placeholder))
@@ -10257,7 +10461,7 @@ comment at the start of cc-engine.el for
 	  )))
 
        ;; CASE 9: we are inside a brace-list
-       ((and (not (c-major-mode-is 'awk-mode)) ; Maybe this isn't needed (ACM, 2002/3/29)
+       ((and (not (c-major-mode-is 'awk-mode))	; Maybe this isn't needed (ACM, 2002/3/29)
 	     (setq special-brace-list
 		   (or (and c-special-brace-lists ;;;; ALWAYS NIL FOR AWK!!
 			    (save-excursion
@@ -10309,7 +10513,7 @@ comment at the start of cc-engine.el for
 	  (if (eq (point) (c-point 'boi))
 	      (c-add-syntax 'brace-list-close (point))
 	    (setq lim (c-most-enclosing-brace c-state-cache (point)))
-	    (c-beginning-of-statement-1 lim)
+	    (c-beginning-of-statement-1 lim nil nil t)
 	    (c-add-stmt-syntax 'brace-list-close nil t lim paren-state)))
 
 	 (t
@@ -10374,27 +10578,27 @@ comment at the start of cc-engine.el for
 	;; From here on we have the next containing sexp in lim.
 	(setq lim (c-most-enclosing-brace paren-state))
 	(goto-char containing-sexp)
-	(cond
+	    (cond
 
-	 ;; CASE 16E: Closing a statement block?  This catches
-	 ;; cases where it's preceded by a statement keyword,
-	 ;; which works even when used in an "invalid" context,
-	 ;; e.g. a macro argument.
-	 ((c-after-conditional)
-	  (c-backward-to-block-anchor lim)
-	  (c-add-stmt-syntax 'block-close nil t lim paren-state))
+	     ;; CASE 16E: Closing a statement block?  This catches
+	     ;; cases where it's preceded by a statement keyword,
+	     ;; which works even when used in an "invalid" context,
+	     ;; e.g. a macro argument.
+	     ((c-after-conditional)
+	      (c-backward-to-block-anchor lim)
+	      (c-add-stmt-syntax 'block-close nil t lim paren-state))
 
-	 ;; CASE 16A: closing a lambda defun or an in-expression
-	 ;; block?  C.f. cases 4, 7B and 17E.
-	 ((setq placeholder (c-looking-at-inexpr-block
+	     ;; CASE 16A: closing a lambda defun or an in-expression
+	     ;; block?	C.f. cases 4, 7B and 17E.
+	     ((setq placeholder (c-looking-at-inexpr-block
 			     (c-safe-position containing-sexp paren-state)
 			     nil))
-	  (setq tmpsymbol (if (eq (car placeholder) 'inlambda)
+	      (setq tmpsymbol (if (eq (car placeholder) 'inlambda)
 			      'inline-close
 			    'block-close))
-	  (goto-char containing-sexp)
-	  (back-to-indentation)
-	  (if (= containing-sexp (point))
+	      (goto-char containing-sexp)
+	      (back-to-indentation)
+	      (if (= containing-sexp (point))
 	      (c-add-syntax tmpsymbol (point))
 	    (goto-char (cdr placeholder))
 	    (back-to-indentation)
@@ -10404,9 +10608,9 @@ comment at the start of cc-engine.el for
 	    (if (/= (point) (cdr placeholder))
 		(c-add-syntax (car placeholder)))))
 
-	 ;; CASE 16B: does this close an inline or a function in
-	 ;; a non-class declaration level block?
-	 ((save-excursion
+	     ;; CASE 16B: does this close an inline or a function in
+	     ;; a non-class declaration level block?
+	     ((save-excursion
 	    (and lim
 		 (progn
 		   (goto-char lim)
@@ -10414,20 +10618,20 @@ comment at the start of cc-engine.el for
 		    (c-most-enclosing-brace paren-state lim)
 		    nil))
 		 (setq placeholder (point))))
-	  (c-backward-to-decl-anchor lim)
-	  (back-to-indentation)
-	  (if (save-excursion
+	      (c-backward-to-decl-anchor lim)
+	      (back-to-indentation)
+	      (if (save-excursion
 		(goto-char placeholder)
 		(looking-at c-other-decl-block-key))
 	      (c-add-syntax 'defun-close (point))
 	    (c-add-syntax 'inline-close (point))))
 
-	 ;; CASE 16F: Can be a defun-close of a function declared
-	 ;; in a statement block, e.g. in Pike or when using gcc
-	 ;; extensions, but watch out for macros followed by
-	 ;; blocks.  Let it through to be handled below.
-	 ;; C.f. cases B.3 and 17G.
-	 ((save-excursion
+	     ;; CASE 16F: Can be a defun-close of a function declared
+	     ;; in a statement block, e.g. in Pike or when using gcc
+	     ;; extensions, but watch out for macros followed by
+	     ;; blocks.	 Let it through to be handled below.
+	     ;; C.f. cases B.3 and 17G.
+	     ((save-excursion
 	    (and (not (c-at-statement-start-p))
 		 (eq (c-beginning-of-statement-1 lim nil nil t) 'same)
 		 (setq placeholder (point))
@@ -10436,39 +10640,39 @@ comment at the start of cc-engine.el for
 		   ;; lacks a type in this case, since that's more
 		   ;; likely to be a macro followed by a block.
 		   (c-forward-decl-or-cast-1 (c-point 'bosws) nil nil))))
-	  (back-to-indentation)
-	  (if (/= (point) containing-sexp)
+	      (back-to-indentation)
+	      (if (/= (point) containing-sexp)
 	      (goto-char placeholder))
-	  (c-add-stmt-syntax 'defun-close nil t lim paren-state))
+	      (c-add-stmt-syntax 'defun-close nil t lim paren-state))
 
-	 ;; CASE 16C: If there is an enclosing brace then this is
-	 ;; a block close since defun closes inside declaration
-	 ;; level blocks have been handled above.
-	 (lim
-	  ;; If the block is preceded by a case/switch label on
-	  ;; the same line, we anchor at the first preceding label
-	  ;; at boi.  The default handling in c-add-stmt-syntax
-	  ;; really fixes it better, but we do like this to keep
-	  ;; the indentation compatible with version 5.28 and
-	  ;; earlier.  C.f. case 17H.
-	  (while (and (/= (setq placeholder (point)) (c-point 'boi))
+	     ;; CASE 16C: If there is an enclosing brace then this is
+	     ;; a block close since defun closes inside declaration
+	     ;; level blocks have been handled above.
+	     (lim
+	      ;; If the block is preceded by a case/switch label on
+	      ;; the same line, we anchor at the first preceding label
+	      ;; at boi.  The default handling in c-add-stmt-syntax
+	      ;; really fixes it better, but we do like this to keep
+	      ;; the indentation compatible with version 5.28 and
+	      ;; earlier.  C.f. case 17H.
+	      (while (and (/= (setq placeholder (point)) (c-point 'boi))
 		      (eq (c-beginning-of-statement-1 lim) 'label)))
-	  (goto-char placeholder)
-	  (if (looking-at c-label-kwds-regexp)
+	      (goto-char placeholder)
+	      (if (looking-at c-label-kwds-regexp)
 	      (c-add-syntax 'block-close (point))
 	    (goto-char containing-sexp)
 	    ;; c-backward-to-block-anchor not necessary here; those
 	    ;; situations are handled in case 16E above.
 	    (c-add-stmt-syntax 'block-close nil t lim paren-state)))
 
-	 ;; CASE 16D: Only top level defun close left.
-	 (t
-	  (goto-char containing-sexp)
-	  (c-backward-to-decl-anchor lim)
-	  (c-add-stmt-syntax 'defun-close nil nil
+	     ;; CASE 16D: Only top level defun close left.
+	     (t
+	      (goto-char containing-sexp)
+	      (c-backward-to-decl-anchor lim)
+	      (c-add-stmt-syntax 'defun-close nil nil
 			     (c-most-enclosing-brace paren-state)
 			     paren-state))
-	 ))
+	     ))
 
        ;; CASE 19: line is an expression, not a statement, and is directly
        ;; contained by a template delimiter.	Most likely, we are in a
@@ -10590,7 +10794,7 @@ comment at the start of cc-engine.el for
 	 ;; CASE 17G: First statement in a function declared inside
 	 ;; a normal block.  This can occur in Pike and with
 	 ;; e.g. the gcc extensions, but watch out for macros
-	 ;; followed by blocks.  C.f. cases B.3 and 16F.
+	 ;; followed by blocks.	 C.f. cases B.3 and 16F.
 	 ((save-excursion
 	    (and (not (c-at-statement-start-p))
 		 (eq (c-beginning-of-statement-1 lim nil nil t) 'same)
@@ -10683,7 +10887,7 @@ comment at the start of cc-engine.el for
 			 (or (not (c-forward-to-cpp-define-body))
 			     (<= (point) (c-point 'boi indent-point)))))
 	      ;; Inside a #define body and the syntactic analysis is
-	      ;; anchored on the start of the #define.  In this case
+	      ;; anchored on the start of the #define.	In this case
 	      ;; we add cpp-define-intro to get the extra
 	      ;; indentation of the #define body.
 	      (c-add-syntax 'cpp-define-intro)))))
@@ -10809,7 +11013,7 @@ Cannot combine absolute offsets %S and %
   ;;
   ;; This function might do hidden buffer changes.
   (let* ((symbol (c-langelem-sym langelem))
-	 (match  (assq symbol c-offsets-alist))
+	 (match	 (assq symbol c-offsets-alist))
 	 (offset (cdr-safe match)))
     (if match
 	(setq offset (c-evaluate-offset offset langelem symbol))
@@ -10880,4 +11084,6 @@ Cannot combine absolute offsets %S and %
 
 (cc-provide 'cc-engine)
 
+;;; arch-tag: 149add18-4673-4da5-ac47-6805e4eae089
 ;;; cc-engine.el ends here
+
--- /dev/null
+++ emacs24-24.3+1/lisp/progmodes/cc-fix.el
@@ -0,0 +1,155 @@
+;;; cc-fix.el --- compatibility library for old (X)Emacs versions
+
+;; Copyright (C) 1985,1987,1992-2003, 2004, 2005, 2006, 2007, 2008,
+;; 2009, 2010, 2011  Free Software Foundation, Inc.
+
+;; Authors:    2003- Alan Mackenzie
+;;             1998- Martin Stjernholm
+;;             1997-1999 Barry A. Warsaw
+;; Maintainer: bug-cc-mode@gnu.org
+;; Created:    03-Jul-1997 (as cc-mode-19.el)
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
+
+;; This file is not part of GNU Emacs.
+
+;; This program is free software; you can redistribute it and/or modify
+;; it under the terms of the GNU General Public License as published by
+;; the Free Software Foundation; either version 3 of the License, or
+;; (at your option) any later version.
+
+;; This program is distributed in the hope that it will be useful,
+;; but WITHOUT ANY WARRANTY; without even the implied warranty of
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; GNU General Public License for more details.
+
+;; You should have received a copy of the GNU General Public License
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
+
+;;; Commentary:
+
+;; This file is necessary in order to run CC Mode in older (X)Emacs
+;; versions.  It's not needed at all for the latest versions of Emacs
+;; and XEmacs.
+
+;;; Code:
+
+(eval-when-compile
+  (let ((load-path
+	 (if (and (boundp 'byte-compile-dest-file)
+		  (stringp byte-compile-dest-file))
+	     (cons (file-name-directory byte-compile-dest-file) load-path)
+	   load-path)))
+    (load "cc-bytecomp" nil t)))
+
+;; Silence the compiler (in case this file is compiled by other
+;; Emacsen even though it isn't used by them).
+(cc-bytecomp-obsolete-fun byte-code-function-p)
+(cc-bytecomp-defun regexp-opt-depth)
+
+(cc-external-require 'advice)
+
+;; Emacs 20.n doesn't have the macros push and pop.  Here're the Emacs 21
+;; definitions.
+(or (fboundp 'push)
+    (defmacro push (newelt listname)
+      "Add NEWELT to the list stored in the symbol LISTNAME.
+This is equivalent to (setq LISTNAME (cons NEWELT LISTNAME)).
+LISTNAME must be a symbol."
+      (list 'setq listname
+	    (list 'cons newelt listname))))
+
+(or (fboundp 'pop)
+    (defmacro pop (listname)
+      "Return the first element of LISTNAME's value, and remove it from the list.
+LISTNAME must be a symbol whose value is a list.
+If the value is nil, `pop' returns nil but does not actually
+change the list."
+      (list 'prog1 (list 'car listname)
+	    (list 'setq listname (list 'cdr listname)))))
+
+
+(if (/= (regexp-opt-depth "\\(\\(\\)\\)") 2)
+    (progn
+      ;; Emacs 21.1 has a buggy regexp-opt-depth which prevents CC
+      ;; Mode building.  Those in Emacs 21.[23] are not entirely
+      ;; accurate.  The following definition comes from Emacs's
+      ;; regexp-opt.el CVS version 1.25 and is believed to be a
+      ;; rigorously correct implementation.
+      (defconst regexp-opt-not-groupie*-re
+	(let* ((harmless-ch "[^\\\\[]")
+	       (esc-pair-not-lp "\\\\[^(]")
+	       (class-harmless-ch "[^][]")
+	       (class-lb-harmless "[^]:]")
+	       (class-lb-colon-maybe-charclass ":\\([a-z]+:]\\)?")
+	       (class-lb (concat "\\[\\(" class-lb-harmless
+				 "\\|" class-lb-colon-maybe-charclass "\\)"))
+	       (class
+		(concat "\\[^?]?"
+			"\\(" class-harmless-ch
+			"\\|" class-lb "\\)*"
+			"\\[?]")) ; special handling for bare [ at end of re
+	       (shy-lp "\\\\(\\?:"))
+	  (concat "\\(" harmless-ch "\\|" esc-pair-not-lp
+		  "\\|" class "\\|" shy-lp "\\)*"))
+	"Matches any part of a regular expression EXCEPT for non-shy \"\\\\(\"s")
+
+      (defun regexp-opt-depth (regexp)
+	"Return the depth of REGEXP.
+This means the number of regexp grouping constructs (parenthesised expressions)
+in REGEXP."
+	(save-match-data
+	  ;; Hack to signal an error if REGEXP does not have balanced
+	  ;; parentheses.
+	  (string-match regexp "")
+	  ;; Count the number of open parentheses in REGEXP.
+	  (let ((count 0) start)
+	    (while
+		(progn
+		  (string-match regexp-opt-not-groupie*-re regexp start)
+		  (setq start ( + (match-end 0) 2)) ; +2 for "\\(" after match-end.
+		  (<= start (length regexp)))
+	      (setq count (1+ count)))
+	    count)))
+      ))
+
+;; Some XEmacs versions have a bug in which font-lock-compile-keywords
+;; overwrites the variable font-lock-keywords with its result.  This causes
+;; havoc when what the function is compiling is font-lock-SYNTACTIC-keywords,
+;; hence....
+(eval-after-load "font-lock"
+  '(when (and (featurep 'xemacs) ; There is now (2005/12) code in GNU Emacs CVS
+				 ; to make the call to f-l-c-k throw an error.
+	      (let (font-lock-keywords)
+		(font-lock-compile-keywords '("\\<\\>"))
+		font-lock-keywords))	; did the previous call foul this up?
+     (defun font-lock-compile-keywords (keywords)
+       "Compile KEYWORDS (a list) and return the list of compiled keywords.
+Each keyword has the form (MATCHER HIGHLIGHT ...).  See `font-lock-keywords'."
+       (if (eq (car-safe keywords) t)
+	   keywords
+	 (cons t (mapcar 'font-lock-compile-keyword keywords))))
+     (defadvice font-lock-fontify-keywords-region (before c-compile-font-lock-keywords
+							  activate preactivate)
+       (unless (eq (car-safe font-lock-keywords) t)
+	 (setq font-lock-keywords
+	       (font-lock-compile-keywords font-lock-keywords))))
+     ))
+
+;; XEmacs 21.4 doesn't have `delete-dups'.
+(if (not (fboundp 'delete-dups))
+    (defun delete-dups (list)
+      "Destructively remove `equal' duplicates from LIST.
+Store the result in LIST and return it.  LIST must be a proper list.
+Of several `equal' occurrences of an element in LIST, the first
+one is kept."
+      (let ((tail list))
+	(while tail
+	  (setcdr tail (delete (car tail) (cdr tail)))
+	  (setq tail (cdr tail))))
+      list))
+
+
+(cc-provide 'cc-fix)
+;;; cc-fix.el ends here
